import { __esDecorate, __runInitializers } from "tslib";
import { ServiceContainerBuilder, injectable } from "@wroud/di";
// Define a service
let Logger = (() => {
    let _classDecorators = [injectable()];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    var Logger = class {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(null) : void 0;
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            Logger = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
            __runInitializers(_classThis, _classExtraInitializers);
        }
        log(message) {
            console.log(message);
        }
    };
    return Logger = _classThis;
})();
// Define another service that depends on Logger
let UserService = (() => {
    let _classDecorators = [injectable(() => [Logger])];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    var UserService = class {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(null) : void 0;
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            UserService = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
            __runInitializers(_classThis, _classExtraInitializers);
        }
        logger;
        constructor(logger) {
            this.logger = logger;
            this.logger = logger;
        }
        createUser(user) {
            this.logger.log(`Creating user: ${user.name}`);
            // User creation logic
        }
    };
    return UserService = _classThis;
})();
// Build the service container
const containerBuilder = new ServiceContainerBuilder();
containerBuilder.addSingleton(Logger);
containerBuilder.addTransient(UserService);
const serviceProvider = containerBuilder.build();
// Resolve and use the UserService
const userService = serviceProvider.getService(UserService);
userService.createUser({ name: "John Doe" });
//# sourceMappingURL=example.js.map